#include<libusb-1.0/libusb.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>

#define TAILLE_MAX 10



typedef struct device {
    libusb_device * device;
    int ADDOUT;
    int ADDIN;
    libusb_device_handle *handle;
    struct libusb_config_descriptor *pdesc;
} *LigneDevice, Device;

//Device devices[TAILLE_MAX];



int findDevices(libusb_context *context)
{
    libusb_device **list;
    ssize_t count=libusb_get_device_list(context,&list);
    if(count<0) {perror("libusb_get_device_list"); exit(-1);}
    ssize_t i=0;
    int rang = -1;

    Device tmp;
    struct libusb_device_descriptor desc;
    int status;

    for(i=0;i<count;i++){
        
        status=libusb_get_device_descriptor(list[i],&desc);
        if(status!=0) continue;
        
        if (desc.idVendor==0x04242 && desc.idProduct==0x01)
        {   tmp.device=list[i];
            tmp.ADDIN = -1;
            tmp.ADDOUT =-1;
            tmp.handle = NULL;
            tmp.pdesc = NULL;
            rang+=1;
            devices[rang]=tmp;
            printf("Device %d : detected\n",rang);
        } 
    }
    libusb_free_device_list(list,1);
    return rang;
}




void selectConfig(Device * dev,int nb)
{
    
    int status;
    status=libusb_get_config_descriptor(dev->device,nb,&dev->pdesc);
    if(status!=0){ perror("libusb_get_config_descriptor"); exit(-1); }

}

void printAdd(Device dev)
{  
    printf("in : %d et out : %d\n",dev.ADDIN,dev.ADDOUT);

}

void findENDpoints(Device * dev)
{
    int nb_end;
    int nb_int = dev->pdesc->bNumInterfaces;
    for (int y = 0;y<nb_int;y++)
    {
        nb_end = dev->pdesc->interface[y].altsetting[0].bNumEndpoints;
        
        for (int i = 0;i<nb_end;i++)
        {   
            uint8_t add = dev->pdesc->interface[y].altsetting[0].endpoint[i].bEndpointAddress;
            int direction = add>>7;
            if (direction) dev->ADDIN = add;
            else dev->ADDOUT = add;
        }  
    }
}


int main(void)
{   
    libusb_context *context;
    int status=libusb_init(&context);
    if(status!=0) {perror("libusb_init"); exit(-1);}

    int nb_devices = findDevices(context);
    
    //On récupère le config descriptor et les adresses des ENDPoints pour chaque device
    for (int i = 0; i<nb_devices+1; i++)
    {   
       
        status=libusb_open(devices[i].device,&(devices[i].handle));
        if(status!=0){ perror("libusb_open"); exit(-1); }
        
        selectConfig(&devices[i],i);
        findENDpoints(&devices[i]);
        printf("device n%d\n",i);
        printAdd(devices[i]);
        
        libusb_close(devices[i].handle);
    }
    
    /*
    unsigned char data = '1';
    char all[3] = "100";
    int transfer;
    while (data != '0'){   
        fgets(all,sizeof(all),stdin);
        data = all[0];
        printf("update : %c\n",data);
        libusb_bulk_transfer(devices[0].handle, devices[0].ADDOUT, &data, sizeof(data), &transfer, 5000);
    }
    
    */
    
    libusb_exit(context);
}

